﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Dynamic_TextBox_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            //Create the dynamic TextBox.
            TextBox textbox = new TextBox();
            int count = panel1.Controls.OfType<TextBox>().ToList().Count;
            textbox.Location = new System.Drawing.Point(10, 25 * count);
            textbox.Size = new System.Drawing.Size(80, 20);
            textbox.Name = "txt_" + (count + 1);
            panel1.Controls.Add(textbox);

            //Create the dynamic Button to remove the TextBox.
            Button button = new Button();
            button.Location = new System.Drawing.Point(95, 25 * count);
            button.Size = new System.Drawing.Size(60, 20);
            button.Name = "btnDelete_" + (count + 1);
            button.Text = "Delete";
            button.Click += new System.EventHandler(this.btnDelete_Click);
            panel1.Controls.Add(button);
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            //Reference the Button which was clicked.
            Button button = (sender as Button);

            //Determine the Index of the Button.
            int index = int.Parse(button.Name.Split('_')[1]);

            //Find the TextBox using Index and remove it.
            panel1.Controls.Remove(panel1.Controls.Find("txt_" + index, true)[0]);

            //Remove the Button.
            panel1.Controls.Remove(button);

            //Rearranging the Location controls.
            foreach (Button btn in panel1.Controls.OfType<Button>())
            {
                int controlIndex = int.Parse(btn.Name.Split('_')[1]);
                if (controlIndex > index)
                {
                    TextBox txt = (TextBox)panel1.Controls.Find("txt_" + controlIndex, true)[0];
                    btn.Top = btn.Top - 25;
                    txt.Top = txt.Top - 25;
                }
            }
        }
    }
}
