﻿Public Class Form1

    Private Sub btnAdd_Click(sender As System.Object, e As System.EventArgs) Handles btnAdd.Click
        'Create the dynamic TextBox.
        Dim textbox As TextBox = New TextBox
        Dim count As Integer = panel1.Controls.OfType(Of TextBox).ToList.Count
        textbox.Location = New System.Drawing.Point(10, (25 * count))
        textbox.Size = New System.Drawing.Size(80, 20)
        textbox.Name = "txt_" & (count + 1)
        panel1.Controls.Add(textbox)
        'Create the dynamic Button to remove the TextBox.
        Dim button As Button = New Button
        button.Location = New System.Drawing.Point(95, (25 * count))
        button.Size = New System.Drawing.Size(60, 20)
        button.Name = "btnDelete_" & (count + 1)
        button.Text = "Delete"
        AddHandler button.Click, AddressOf Me.btnDelete_Click
        panel1.Controls.Add(button)
    End Sub

    Private Sub btnDelete_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Reference the Button which was clicked.
        Dim button As Button = CType(sender, Button)

        'Determine the Index of the Button.
        Dim index As Integer = Integer.Parse(button.Name.Split("_")(1))

        'Find the TextBox using Index and remove it.
        panel1.Controls.Remove(panel1.Controls.Find(("txt_" & index), True)(0))

        'Remove the Button.
        panel1.Controls.Remove(button)

        'Rearranging the Location controls.
        For Each btn As Button In panel1.Controls.OfType(Of Button)()
            Dim controlIndex As Integer = Integer.Parse(btn.Name.Split("_")(1))
            If (controlIndex > index) Then
                Dim txt As TextBox = CType(panel1.Controls.Find(("txt_" & controlIndex), True)(0), TextBox)
                btn.Top = (btn.Top - 25)
                txt.Top = (txt.Top - 25)
            End If
        Next
    End Sub
End Class
